<template>
  <div class="flex flex-col w-full gap-4">
    <div v-for="(edit, index) in editores" :key="index" class="w-full">
      <editor
        :idproject="idproject"
        :index="index"
        :iseditable="iseditable"
        v-if="edit.type === 'text'"
        :identificador="edit"
        @delete="handleDeleteEditor"
      ></editor>
      <videos
        :idproject="idproject"
        :index="index"
        :iseditable="iseditable"
        v-if="edit.type === 'video'"
        :identificador="edit"
        @delete="handleDeleteEditor"
      ></videos>
      <gallery
        :idproject="idproject"
        :index="index"
        :iseditable="iseditable"
        v-if="edit.type === 'gallery'"
        :identificador="edit"
        @delete="handleDeleteEditor"
      ></gallery>
    </div>
    <div class="w-full">
      <button
        class="px-4 py-2 text-sm font-medium text-white transition bg-blue-600 w-max hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500"
        data-bs-toggle="modal"
        data-bs-target="#modalType"
        type="button"
      >
        Añadir Seccion
      </button>

      <div
        class="modal fade"
        id="modalType"
        tabindex="-1"
        aria-labelledby="exampleModalLabelType"
        aria-hidden="true"
      >
        <div class="modal-dialog">
          <div class="modal-content dark:bg-gray-800 dark:text-white">
            <div class="modal-header">
              <h5 class="font-semibold modal-title" id="exampleModalLabelType">
                Editor
              </h5>
              <button
                type="button"
                class="btn-close dark:text-white"
                data-bs-dismiss="modal"
                aria-label="Close"
              ></button>
            </div>
            <div class="modal-body">
              <div class="flex flex-col w-full gap-3">
                <select class="form-select dark:bg-gray-800" v-model="typeSection" id="">
                  <option value="Video">Video</option>
                  <option value="Galeria">Galeria</option>
                  <option value="Texto">Texto</option>
                </select>
                <!-- <div v-if="typeSection === 'Texto'" class="flex gap-3">
                  <span>Color del fondo</span
                  ><input v-model="currentColor" type="color" />
                </div>
                <div v-if="typeSection === 'Texto'" class="flex gap-3">
                  <span>Color del texto</span
                  ><input v-model="currentTextColor" type="color" />
                </div> -->
              </div>
            </div>
            <div class="modal-footer">
              <button
                type="button"
                class="px-4 py-2 text-sm font-medium  transition focus:outline-none focus:ring-2 focus:ring-offset-2 dark:text-white"
                data-bs-dismiss="modal"
              >
                Cerrar
              </button>
              <button
                @click="handleAddEditor()"
                type="button"
                class="px-4 py-2 text-sm font-medium text-white transition bg-blue-600 hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500"
                data-bs-dismiss="modal"
              >
                Añadir
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import editor from "../components/v-text.vue";
import gallery from "../components/v-gallery.vue";
import videos from "../components/v-video.vue";
export default {
  props: {
    iseditable: {
      type: Boolean,
      default: false,
    },
    title: {
      type: String,
      default: "",
    },
    contenido: {
      type: String,
      default: "",
    },
    idproject: {
      type: Number,
      default: 1,
    },
  },
  data() {
    return {
      typeSection: "",
      editores: [],
      count: 0,
      currentColor: "#000000",
      currentTextColor: "#ffffff",
    };
  },
  mounted() {
    if (this.contenido != "") {
      let editoresTmp = JSON.parse(this.contenido);
      this.count = editoresTmp.length;
      // console.log(editoresTmp.length)
      editoresTmp.forEach((element, index) => {
        if (element.type == "text") {
          this.axios.get(`/api/project/${this.idproject}/projecttext/${element.orden}`).then((response) => {
            this.editores.push({
              id: element.id,
              orden: element.orden,
              type: element.type,
              color: response.data.bgcolor,
              textColor: "",
              content: response.data.content,
            });
            this.ordenEditor();
          });
        }
        if (element.type == "video") {
          this.axios.get(`/api/project/${this.idproject}/projectvideo/${element.orden}`).then((response) => {
            this.editores.push({
              id: element.id,
              orden: element.orden,
              type: element.type,
              title: this.title,
              content: response.data,
            });
            this.ordenEditor();
          });
        }
        if (element.type == "gallery") {
          this.axios
            .get(`/api/project/${this.idproject}/projectgallery/${element.orden}`)
            .then((response) => {
            //   console.log(response.data.imgs);
              this.editores.push({
                id: element.id,
                orden: element.orden,
                type: element.type,
                title: this.title,
                content: response.data.imgs.length>0?JSON.parse(response.data.imgs):[],
              });
              this.ordenEditor();
            });
        }
      });
    }
  },
  // watch: {
  //   editores: {
  //     handler() {
  //       this.ordenEditor();
  //       this.handleModifyOrden();
  //     },
  //     deep: true,
  //   },
  // },
  methods: {
    ordenEditor() {
      this.editores.sort((a, b) => a.orden > b.orden ? 1 : -1);

    },
    handleDeleteEditor(index){
      this.editores.splice(index, 1);
      this.ordenEditor();
      this.handleModifyOrden();
    },
    handleModifyOrden() {
      let elementos=[];
      this.editores.forEach((element, index) => {
        elementos.push({
          id: element.id,
          orden: element.orden,
          type: element.type,
        });
      });
      this.axios
        .put("/api/project/" + this.idproject, {
          contentOrden: JSON.stringify(elementos),
        })
        .then((response) => {});
    },
    handleAddEditor() {
      if (this.typeSection == "") return;
      this.count++;

      if (this.typeSection == "Video") {
        this.axios
          .post(`/api/project/${this.idproject}/projectvideo`, {
            projectid: this.idproject,
            projectorden: this.count,
          })
          .then((response) => {
            // console.log(response.data);
            let editor = {
              type: "video",
              id: response.data.id,
              orden: this.count,
              title: this.title,
              content: response.data,
            };
            this.editores.push(editor);
            this.handleModifyOrden();
          });
      }
      if (this.typeSection == "Galeria") {
        this.axios
          .post(`/api/project/${this.idproject}/projectgallery`, {
            projectid: this.idproject,
            projectorden: this.count,
          })
          .then((response) => {
            this.editores.push({
              id: response.data.id,
              orden: this.count,
              type: "gallery",
              title: this.title,
              content: {class: "", imgs: []},
            });
            this.handleModifyOrden();
          });
      }
      if (this.typeSection == "Texto") {
        this.axios
          .post(`/api/project/${this.idproject}/projecttext`, {
            projectid: this.idproject,
            projectorden: this.count,
            bgcolor: this.currentColor,
          })
          .then((response) => {
            this.editores.push({
              id: response.data.id,
              orden: this.count,
              type: "text",
              color: response.data.bgcolor,
              textColor: this.currentTextColor,
              content: response.data.content,
            });
            this.currentColor = "#000000";
            this.currentTextColor = "#ffffff";
            this.handleModifyOrden();
          });
      }
      this.typeSection = "";
    },
  },
  components: {
    editor,
    gallery,
    videos,
  },
};
</script>
